; ott1.asm: Windows kdols, kvarcoszcilltor vagy kermia rezontor.
; Szles hmrskleti tartomnyban hasznlhat.

	list		p=16f1704      
	list		r=dec
	#include	<p16f1704.inc> 

	__CONFIG _CONFIG1, _FOSC_HS & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF  & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF  & _FCMEN_OFF
	__CONFIG _CONFIG2, _WRT_OFF & _PLLEN_ON & _STVREN_OFF & _BORV_LO & _LVP_OFF
	
; Vltozk

	cblock	0x20
	eebuf:8 ; eeprom (visszaolvas) buffer
	wptr:2	; eeprom rsi mutat (ellenrztt, aktv)
	wpts:2	; eeprom rsi mutat (flash-bl visszaolvasott)
	rptr:2	; eeprom olvassi mutat (olvass funkcihoz)
	addrnum	; i2c specilis (cm vagy parancs) bjtok szma
	datnum	; i2c adatbjtok szma
	fej	; rarekord fejlcbjtja
	clkblk:7 ;rablokk
	i2csave	; i2c cm ment regiszter
	i2ccnt	; i2c bjtszmll
	errreg	; hibaregiszter (lehet, hogy megvltozik)
	regcim	; ramveletek spec bjtja (regisztercm)
	clkvez:2 ; ra vezrlbjtok helye
	scnt	; soros ad szmllja 
	ccount	; ciklusszervezs konverzis szubrutin szmllja
	separ	; elvlaszt karakter (.hh.nn, de :pp)
	
	endc
	cblock	0x70
	ah
	al
	bh
	bl
	ch
	cl
	aux
	flags	; jelzbitek
	f1	; tovbbi jelzbitek
	tpage	; szveglap cme
	tbase	; szvegbjt cme (tltskor a kezdcm)
	rxcnt	; soros vtel bjtszmllja
	errcnt
	endc
	
	cblock	0xa0
	rcvblk:16	; vev
	sndblk:16	; ad
	ffblk:8		; 8 db ff lesz benne 8 bjt trlshez
	adbuf:2		; itt fordtom meg az A/D eredmnyt
	txcnt		; soros ad bjtszmllja
	endc
	
;aliasok
#define	vesz	flags,7	; vtelt krtem az i2ccomm szubrutintl
#define norm	flags,6	; adatblokk van soron az i2c-n
#define nment	flags,5	; mg nem volt mutatments 
#define	ures	flags,4	; mg nincs mentett mutat
#define	mhiba	flags,3	; a mentett mutat hibsnak bizonyult
#define datum	flags,2	; dtumot kell kirni (nem idpontot)
#define parancs	flags,1	; parancsot fogott a vev
#define	televan	flags,0	; az EEPROM megtelt
#define	pass2	f1,7	; rallts 2. menete (ellenrzs)

#define	xstp	clkvez+1,4 ; az ra megllt (llapotbit)
#define i2cerr	errreg,3 ; i2c hiba

; makrk:
; makrofjlok
	#include <prlx.inc>
	#include <ptrmac.inc>
; inicializlsok
; csak a prbaverziban van 
oscini	macro
	banksel	osccon
	movl	osccon,78h	; 16 MHz bels
	endm
	
adcini	macro	; A/D konverter jobbra igazt, gyors
	banksel	adcon0
	movl	adcon0,9
	movl	adcon1,0d0h
	movl	adcon2,80h
	clrf	adresl
	clrf	adresh
	banksel	0
	bcf	pir1,adif
	endm
cmp1ini	macro	; 1. kompartor fvr poz ref, 3. neg.bemenet
	banksel	cm1con0
	movl	cm1con0,8eh	; nem invertl
	movl	cm1con1,0b3h
	endm
fvrini	macro	; 2,048 V a kompartornak
	banksel	fvrcon
	movl	fvrcon,88h
	endm
i2cini	macro	; i2c master
	banksel	ssp1stat
	clrf	ssp1stat
	movl	ssp1con1,28h
	clrf	ssp1con3
	movl	ssp1add,1fh	; 250 kHz, 400-ig mehetne!
	endm
serini	macro	; soros port, megszakts nlkl, 19200 8n1
	banksel	baud1con
	movl	baud1con,48h
	movl	rc1sta,90h
	movl	tx1sta,26h
	movl	spbrgl,0cfh
	clrf	spbrgh
	endm
tmr1ini	macro	; timer1, teljes kr, de mg nem indtja el!
	banksel	0
	movl	t1con,30h
	clrf	t1gcon
	clrf	tmr1h
	clrf	tmr1l
	bcf	pir1,tmr1if
	endm
	
; ktbjtos vltoz lapon belli mozgatsa, dest=cl, src=forrs
movd	macro	dest,src
	mov	dest,src
	mov	dest+1,src+1
	endm
; megszaktstilts
disi	macro
	bcf	intcon,gie
	endm
eni	macro
	bsf	intcon,gie
	endm
; vev alaplls
flush	macro
	disi
	clrf	rxcnt
	bcf	parancs
	eni
	endm
	
; Program kezdete
	org	0
	nop
	pagesel	start
	goto	start
; Megszakts.	Az A/D kezelse tkerlt a fprogramba. A kompartor 
; megszakts a programmemriba ments miatt megvltozott. 
	org	4
	banksel	pie1
	jnb	pie2,c1ie,skcomp
	banksel	pir1
	jnb	pir2,c1if,skcomp
	bcf	pir2,c1if
	call	saveptr
altat
	sleep
	nop
	goto	altat
skcomp	; a soros vtel kezelse viszont a megszaktsba kerlt:
	banksel	0
	btfss	pir1,rcif
	retfie
	wptpt1	rcvblk	; fsr1 rcvblk-ra mutat
	movf	rxcnt,w	; rxcnt annyi, amennyi 
	addwf	fsr1l,f	; biztosan nem lp lapot!
	banksel	rcreg
	movf	rcreg,w	; ez trli rcif-et
	snb	parancs	; nem rakja le, amg parancs=1
	retfie
	movwf	indf1
	call	sersendw	; echo amg parancs=0
	movlw	0dh	; ha akr 0dh-t, akr
	xorwf	indf1,w
	snz
	bsf	parancs
	movlw	0ah	; 0ah-t rakott le,
	xorwf	indf1,w
	snz
	bsf	parancs	; parancs=1 lesz, a msikat mr nem rakja le
	banksel	0
	sb	parancs
	incf	rxcnt,f	; ha parancs=1, a szmll nem n tovbb
	snb	rxcnt,4
	bsf	parancs	; akkor is ez van, ha a vevpuffer megtelik.
	retfie
	
; Fprogram
start
	banksel	lata
	movl	lata,0x3c	; teszt kimenetek ra0, ra1-en =0
	clrf	latc		; ha brmi kimenet, az indul rtke 0
	banksel	trisa
	movl	trisc,0x3f
	movl	trisa,0x0c
	bcf	option_reg,7	; lehetnek bels felhzk
	bcf	option_reg,tmr0cs
	banksel	ansela
	movl	ansela,4
	movl	anselc,8
	banksel	wpua
	movl	wpua,0bh	; ra0,ra1 felhzva, ha bemenet lenne
	clrf	wpuc
;perifrik lbkiosztsa
	banksel	ppslock		; bemenetek csoportja (+lock)
	movl	ppslock,55h	; unlock szekvencia
	movl	ppslock,0ah
	bcf	ppslock,ppslocked
	movl	sspclkpps,10h	; SCL bemenet=RC0
	movl	sspdatpps,11h	; SDA bemenet=RC1
	movl	clcin0pps,12h	; RT ra percjele=RC2
	movl	rxpps,15h	; RX bemenet=RC5
	banksel	rc0pps		; kimenetek csoportja
	movl	rc0pps,10h	; RC0=SCL kimenet	
	movl	rc1pps,11h	; RC1=SDA kimenet
	movl	rc4pps,14h	; RC4=TX kimenet
	banksel	ppslock		; lock 
	movl	ppslock,55h	; lock szekvencia
	movl	ppslock,0ah
	bsf	ppslock,ppslocked
	
; incializlsok
	#include <clc1.inc>	; clc1 az inc fjl szerint
;	oscini
	adcini
	fvrini
	i2cini
	serini
	tmr1ini		; tmr1 csak a kezdeti ksleltetst intzi
	banksel	0	; csak szoksbl, tmr1ini ott dolgozik
	flush
	movl	fej,0a5h	; idpont fejlcbjtja
	call	fffill8		; ff blokk elksztse 
; vrakozs a tpfeszltsg stabilizcijra (kb. 250 ms)
	bsf	t1con,tmr1on
t1lp1
	sb	pir1,tmr1if
	goto	t1lp1
	bcf	pir1,tmr1if
t1lp2
	sb	pir1,tmr1if
	goto	t1lp2
	bcf	pir1,tmr1if
	bcf	t1con,tmr1on
	cmp1ini		; csak stabilizci utn
	banksel	0
	clrf	pir2	; kompartor megszakts miatt
	clrf	pir1
	banksel	pie1
	bsf	pie1,rcie	; soros vteli megszakts eng.
	bsf	pie2,c1ie	; kompartor megszakts eng.
	banksel	0
	clrf	flags
	bsf	intcon,peie
	bsf	intcon,gie	; mostantl lehet megszaktani
; Itt meg kellene nzni a kompartor kimenett, s le kellene lni
; a programot, ha magas, de tegye meg az,aki biztosra akar menni!
; Helyzetfelmrs
; megy az ra?
	call	rdcstat	; beolvassa 
	snb	xstp
	goto	oraall	; ra megllt, lltani kell
oramegy	; most mr biztosan megy az ra, de mrni mg nem tud:
	call	readptr	; wpts-be olvassa a mentett mutatt.
	call	clrflash ; tbbszr gysem hasznlhat!
; mentett rsi mutat pros? (ha nem, az hiba)
 	snb	wpts+1,0
 	bsf	mhiba	; akkor is, ha ff, azaz nincs mentett mutat
; mentett mutat res helyre mutat? (ha nem, az hiba)
 	movd	rptr,wpts
 	bcf	rptr+1,0	; ha pratlan, lefel kerekt prosra
 	movlw	1
 	movwf	datnum
 	call	eerd
 	incf	eebuf,w
 	sz
 	bsf	mhiba		; mert nem ff van eebuf-ban
; mutat rekonstrulsa ff blokk alapjn
reconst
	clrf	rptr
	clrf	rptr+1
	call	eerd1	
	incpt	rptr,16
	snb	rptr,7
	bsf	televan	; megtelt
	decpt	rptr,8
	snb	televan
	goto	vanptr
	incf	eebuf,w
	sz
	goto	reconst+2
vanptr
; tallt 8 res bjtot mg 7ff0 alatt: rptr mr a kvetkezre mutat,
; mikzben a mentett mutat mg lehet, hogy az elzben jr.
; rptr visszalltsa
	decpt	rptr,8	; ott van, ami fltt 8-cal res a sor 
; wpts felkerektse (idpont kvetkezik!)
	rndup8	wpts
; most mr meg kell egyeznik:
	movf	wpts,w
	xorwf	rptr,w
	snz
	bsf	mhiba
	movf	wpts+1,w
	xorwf	rptr+1,w
	bsf	mhiba
; miutn a vizsglat befejezdtt, rptr:2 mindenkpp a j mutatt
; tartalmazza, teht:
	disi
	movd	wptr,rptr	; rptr ttehet wptr-be, mint j.
	eni
;itt rom ki a pointert, s nem j!
	call	txnl
	wptpt0	wptr
	wptpt1	sndblk
	call	binhexu
	call	binhexu
	movl	scnt,4
	call	txblk
; (mhiba hibazenetet rhatna a terminlra,ms szerepe nincs, a
; futst nem akadlyozza, a mutat helyrelltsa megtrtnt.)
; rsi mutat s ra is rendben, jhet az adatgyjts, ami 
; idpont bejegyzs rsval kezddik.
firstclk
	call	rdclk	; ra olvassa, tudja
	call	wrtrec	; idpont bejegyzs rsa
	snb	televan
	goto	main
	disi
	incpt	wptr,8
	eni
	goto	main		

oraall	
	flush
	sb	parancs
	goto	oraall+1	; nincs parancs
	snb	rxcnt,4
	goto	oraall	; megtelt (szemttel) a vteli sor
cimez	; van parancs s nem bf miatt
	movf	rxcnt,f
	snz
	call	err1out	
	call	settd
	goto	oramegy	
	
main
; figyelni kell az j adat megjelenst, s menteni kell, ha megjtt
; (persze csak ha van hely az EEPROM-ban), s ugyanezt a feladatot
; be kell gyazni a terminlszerver minden vrakozsi hurkba ill.
; a kiolvassban minden sor feldolgozsa utnra.
	banksel	porta
	call	savres
; s kezelni kell a terminlt, ehhez a parancs bitet kell figyelni,
; az jelzi, hogy cr vagy lf jtt:
	sb	parancs
	goto	main	; nincs parancs
	sb	rxcnt,4
	goto	elrak
	flush
	goto	main	; megtelt (szemttel) a vteli sor
elrak
	movf	rxcnt,f
	snz
ujparancs
	call	menuout	; magban ll cr vagy lf fment r ki
	flush
; amikor a fmen van kint, 1 karakteres vlaszt vrok, ha nem az 
; jn, megyek main-re
tslp1
	call	savres	; mert ez is egy vrakozsi hurok
	sb	parancs
	goto	tslp1	; amg nem jn semmi
	decf	rxcnt,w
	jz	pfeld
	flush
	goto	main
pfeld
	banksel	rcvblk
	movf	rcvblk,w
	banksel	0
	andlw	3
	brw
	goto	kilep
	goto	dattim
	goto	rdoute
	goto	clre
kilep
	flush
;	call	txbel
	goto	main	;mkdik
clre	; trls (helyett j kezdetet rak a nulls cmre)
	disi
	clrf	wptr
	clrf	wptr+1
	eni
	call	rdclk	; ra olvassa
	call	skround	; idpont bejegyzs rsa
	movl	tmr1h, high 62000
	movl	tmr1l, low 62000
	bcf	pir1,tmr1if
	bsf	t1con,tmr1on
t1lp6
  sb	pir1,tmr1if
  goto	t1lp6
  bcf	t1con,tmr1on	; id lejrt
  bcf	pir1,tmr1if
	call	preamble+5
	disi
	incpt	wptr,8
	eni
vissza
	flush
	goto	ujparancs	; ezt taln nem lehetett elrontani
dattim
	bcf	pass2
	call	settd
	call	rdclk
	call	wrtrec	;  mirt nem rja?
	incpt	wptr,8	
	goto	vissza		
	
rdoute	; az EEPROM kiolvassa nulltl az els ff kezdet sorig
	clrf	rptr
	clrf	rptr+1
rdcyc		; mkdik, konvertl, kivisz, lell
	call	eerd8	; els 8 bjt eebuf-ba
	incpt	rptr,8	; kvetkezre ll
	incf	eebuf,w
	snz
	goto	vissza	; els bjt ff, olvass vge
	movlw	0a5h
	xorwf	eebuf,w
	snz
	goto	orarek
	mov	ah,eebuf
	mov	al,eebuf+1
	call	bibcd16
	movl	fsr0l,low ch
	movl	fsr0h,high ch
	movl	fsr1h,high sndblk
	movl	fsr1l,low sndblk
	call	binhexu
	call	binhexu
	movl	scnt,4
	call	txblk
	call	txnl
	incf	eebuf+2,w
	snz
	goto	erdcyc
	mov	ah,eebuf+2
	mov	al,eebuf+3
	call	bibcd16
	movl	fsr0l,low ch
	movl	fsr0h,high ch
	movl	fsr1h,high sndblk
	movl	fsr1l,low sndblk
	call	binhexu
	call	binhexu
	movl	scnt,4
	call	txblk
	call	txnl
	incf	eebuf+4,w
	snz
	goto	erdcyc
	mov	ah,eebuf+4
	mov	al,eebuf+5
	call	bibcd16
	movl	fsr0l,low ch
	movl	fsr0h,high ch
	movl	fsr1h,high sndblk
	movl	fsr1l,low sndblk
	call	binhexu
	call	binhexu
	movl	scnt,4
	call	txblk
	call	txnl
	incf	eebuf+6,w
	snz
	goto	erdcyc
	mov	ah,eebuf+6
	mov	al,eebuf+7
	call	bibcd16
	movl	fsr0l,low ch
	movl	fsr0h,high ch
	movl	fsr1h,high sndblk
	movl	fsr1l,low sndblk
	call	binhexu
	call	binhexu
	movl	scnt,4
	call	txblk
	call	txnl
	call	savres
	goto	rdcyc
erdcyc
;	rndup8	rptr
	goto	rdcyc
orarek
	call	ehne
	movl	scnt,8
	call	txblk
	call	txsp
	call	opme
	movl	scnt,8
	call	txblk
	call	txnl
	goto	rdcyc
	
settd	; ez egy eltvedt szubrutin!
	bcf	pass2
	movl	tpage,high rdatum
	movl	tbase,low rdatum
	call	szovegki	; kirta
	clrf	pclath
	sb	pass2
	call	rdclk	; elszr rt olvas clkblk-ba	
	call	ehno	; 10 karaktert berak az adpufferbe
	call	txblk	; leadja, de az egyelre hlyesg
ujprd
	movl	tbase,low udatum
	call	szovegki	; kirta
	clrf	pclath
	flush	; mostantl vehet jra
tslp3
	call	savres	; mert ez is egy vrakozsi hurok
	sb	parancs
	goto	tslp3	; amg nem jn komplett sor
	; bejtt, mert a CR-t mg echzta, az lf-et mr nem
	movf	rxcnt,w
	jz	timtim
	xorlw	8
	sz
	goto	ujprd	; itt visszafordul!
	call	nhe
timtim
	movl	tpage,high rido
	movl	tbase,low rido
	call	szovegki
	clrf	pclath
	sb	pass2
	call	rdtim
	call	opmo
	movl	scnt,8
	call	txblk
ujprt
	movl	tbase,low uido
	call	szovegki
	clrf	pclath
	flush	; mostantl vehet jra
tslp4
	call	savres	; mert ez is egy vrakozsi hurok
	sb	parancs
	goto	tslp4	; amg nem jn komplett sor
	movf	rxcnt,w
	jz	dtveg
	xorlw	8
	sz
	goto	ujprt
	call	mpo
	bsf	pass2
	goto	settd+1
dtveg		; rja s indtja az rt
	call	setclk
	movl	clkvez,5
	movl	clkvez+1,28h
	call	startclk
	return
; nem krds, hogy mkdik, mert a dtum s id bellts visszaaadja,
; nvekv idvel.
	
	#include flash.inc
	#include i2c.inc
	#include conv.inc
	#include texts.inc	; Windows karakterkszlettel
	;#include texts852.inc	; 852-es karakterkszlettel
; itt a vge
	end	
	 