; I2C szubrutinok
; indirekt cmzsre mindkt irnyban fsr0-t hasznljk.

; 1. Elemi szint 

i2cstart ; startbit kldse
  banksel ssp1con2
  bsf ssp1con2,sen
  banksel pir2
i2cslp
  btfss pir1,ssp1if
  goto i2cslp
  bcf pir1,ssp1if
  banksel 0
  return	

i2crstart ; ismtelt start
  banksel ssp1con2
  bsf ssp1con2,rsen
  goto i2cslp-1	

i2cstop ; stopbit
  banksel ssp1con2
  bsf ssp1con2,pen
  goto i2cslp-1	

i2csendb ; bjt kldse (indirekt)
  btfss norm
  moviw	fsr0++
  btfsc	norm
  moviw	fsr1++
  banksel ssp1buf
  movwf ssp1buf
  goto i2cslp-1	

i2csendw ; bjt kldse (W-bl)
  banksel ssp1buf
  movwf ssp1buf
  goto i2cslp-1	

i2cchkack ; nyugtzs ellenrzse
  bcf	i2cerr
  banksel ssp1con2
  btfsc ssp1con2,ackstat
  bsf i2cerr
  banksel 0
  return

i2crcvb ; bjt vtele
  banksel ssp1con2
  bsf  sspcon2,rcen
  banksel pir2
i2crblp
  btfss pir1,ssp1if
  goto i2crblp
  bcf pir1,ssp1if
  banksel ssp1buf
  movf ssp1buf,w
  movwi	fsr1++
  banksel 0
  return	

i2csack ; pozitv nyugtzs
  banksel ssp1con2
  bcf ssp1con2,ackdt
  bsf ssp1con2,acken
  goto i2cslp-1	

i2csnak; negatv nyugtzs
  banksel ssp1con2
  bsf ssp1con2,ackdt
  bsf ssp1con2,acken
  goto i2cslp-1	

; 2. Adatblokkok mozgatsa

; i2csblk (blokk ads) s i2crblk (blokk vtel) szubrutin.
; Felttelezik,hogy a mozgatand bjtok szmt elzetesen elhelyeztk 
; i2ccnt-ben. A kommunikcis szubrutinbl hvhatk.
i2csblk
  call  i2csendb
  call  i2cchkack
  btfsc i2cerr
  return
  decfsz i2ccnt,f
  goto  i2csblk
  return

i2crblk
  call i2crcvb
  decfsz i2ccnt,w
  call  i2csack		
  decfsz i2ccnt,f
  goto  i2crblk
  goto	i2csnak

; 3. ltalnos I2C kommunikcis szubrutin
; Paramterei: specilis bjtok szma addrnum, kezdcme fsr0,
; adatbjtok szma datnum, kezdcme datadd, I2C cm W, irny a
; vesz bitvltozban, hibabit errreg,i2cerr.
 
i2ccomm
  movwf i2csave
  bcf norm
  call i2cstart
  call	i2csendw
  call  i2cchkack
  btfsc i2cerr
  goto	i2cstop
  movf addrnum,w
  movwf i2ccnt
  call i2csblk 
  btfsc i2cerr
  goto	i2cstop
  bsf norm
  movf datnum,w
  movwf i2ccnt
  btfsc vesz
  goto i2crcv
  call i2csblk
  goto i2cstop
i2crcv
  call	i2crstart
  bsf i2csave,0
  movf i2csave,w
  call i2csendw
  call i2crblk
  bcf vesz
  goto i2cstop

; 4. rakezels, az ra cme 64h
rdcstat ; llapotolvass
  bsf vesz
  movlw 1
  movwf  addrnum
  movlw 0e0h
  movwf  regcim
  wptpt0 regcim
  movlw 2
  movwf datnum
  wptpt1 clkvez
  movlw 64h
  goto i2ccomm

rdclk ; raolvass
  bsf vesz
  movlw 1
  movwf  addrnum
  movlw 0
  movwf  regcim
  wptpt0 regcim
  movlw 7
  movwf datnum
  wptpt1 clkblk
  movlw 64h
  goto i2ccomm
  
rdtim	; idpont olvassa (nem rja fell a dtumot)
  bsf vesz
  movlw 1
  movwf  addrnum
  movlw 0
  movwf  regcim
  wptpt0 regcim
  movlw 3
  movwf datnum
  wptpt1 clkblk
  movlw 64h
  goto i2ccomm

setclk ; rabellts
  movlw 1
  movwf  addrnum
  movlw 0
  movwf  regcim
  wptpt0 regcim
  movlw 7
  movwf datnum
  wptpt1 clkblk
  movlw 64h
  goto i2ccomm

startclk ; raindts
  movlw 1
  movwf  addrnum
  movlw 0e0h
  movwf  regcim
  wptpt0 regcim
  movlw 2
  movwf datnum
  wptpt1 clkvez
  movlw 64h
  goto i2ccomm

; 5. EEPROM kezels (24LC256 az a0h cmen)
; A bels rsi cm wptr, az olvassi rptr, mindkett ktbjtos, 
; 15 hasznos bittel

; Idpont bejegyzs rsa 8-cal oszthat cmre
wrtrec
  movlw 7
  disi
  andwf	wptr+1,w
  snz
  goto skround	; ha 8-cal oszthat, nem kerekti fel
  rndup8 wptr	; ha nem oszthat, felkerekti
skround
  eni
  call	preamble ; muszj lenne ff-eket raknia, mert kerek 8!
  snb	televan	; ha televan=1, akkor baj van!
  return
  wptpt1 fej	; a clkblk eltti bjt az adatblokk kezdete
  movlw	8
  movwf datnum	; 8 bjtos adatblokk
  goto eewr
; gy lp ki, hogy wptr a sajt elejre mutat, inc 8 kell utna.

; FF sor rsa eeprom-ba, ha az rsi cm 8-cal oszthat.
; Klnben simn visszatr, nem  r ff-eket.
;  ellenriz, minden EEPROM rs eltt meg kell hvni.
; Elszr  ri el az EEPROM tetejt, ezrt azt is 
; ellenrzi. A legfels 8+8 bjt mindig FF marad.
preamble
  banksel 0
  movlw	7
  andwf	wptr+1,w
  sz
  return ; mert nem oszthat
  disi
  incpt	wptr,8
  eni
wrtff	; 8 db ff rsa, a cm mr wptr-ben
  wptpt1 ffblk
  movlw	8
  movwf datnum
  call	eewr	; berta az ff-eket 
  banksel 0
  movl	tmr1h, high 60000
  movl	tmr1l, low 60000
  bcf	pir1,tmr1if
  bsf	t1con,tmr1on
t1lp5
  sb	pir1,tmr1if
  goto	t1lp5
  bcf	t1con,tmr1on	; id lejrt
  bcf	pir1,tmr1if
  disi	 
  incpt wptr,8
  snb	wptr,7
  bsf televan
  decpt	wptr,16
  eni
  return
 
 ; 2 bjt (A/D eredmny) rsa adbuf:adbuf+1-bl, teljes rtk
 ; mutatmozgatssal, ha kell, eltrlssel:
wrres
  call preamble ; eltrls, ha kell
  snb televan
  return
  wptpt1 adbuf	; fsr1 adbuf-ra mutat
; 2 bjt rsa a mr fsr1-ben lev cmrl, aki itt akar belpni,
; annak az eltrlsrl kln kell gondoskodnia:
wrt2b
  movlw 2
  movwf	datnum	; adatbjtok szma
  call	eewr	; ez mindig indf0-rl veszi az EEPROM bels cmt
  disi
  incpt	wptr,2	; ez nveli vgrehajts utn az rsi mutatt.
  eni
  return

; EEPROM olvass. Az rsi mutat helyrelltshoz minden 8 bjtos
; blokk els bjtjt olvassuk, a tartalom kiolvasshoz pedig a 
; teljes 8 bjtos blokkot. Mindkt esetben rptr a bzis. rptr 
; mdostsa a kvetkez olvass eltt kln feladat. Az eerdn 
; belpsi pont a nem tipikus olvassi feladatokat tudn kiszolglni.
eerd1	; 1-et olvas, nem lp a mutat
  movlw 1
  goto eerdn	  
; 8 bjt olvassa eebuf-ba, nem lp a mutat
eerd8
  movlw	8
eerdn	; w-ben kapott szm ...
  movwf datnum
  wptpt1 eebuf
  goto eerd
  
; EEPROM alaprutinok: elttk az adatterletet meg kell 
; hatrozni: hossz datlen-ben, RAM cm fsr1-ben legyen
eewr ; eeprom rs wptr-tl kezdve
  movlw 2
  movwf  addrnum
  wptpt0 wptr
  movlw 0a0h
  goto i2ccomm
  
eerd ; eeprom olvass rptr-tl kezdve
  movlw 2
  movwf  addrnum
  wptpt0 rptr
  bsf vesz
  movlw 0a0h
  goto i2ccomm
  
; 6. A/D kezels (EEPROM-ba ments a vge)
; A/D kezels. A segdregiszterek megfordtjk a cmsorrendet, gy
; az EEPROM-ban mr a fels bjt lesz az alacsonyabb cmen.
savres	; eredmny mentse, jelzbit trlse
	banksel	0
	sb	pir1,adif
	return
	bcf	pir1,adif
	; az ra IC perc kimenett a programbl kell trlni!
	movl	clkvez,5
	movl	clkvez+1,28h
	call	startclk	; ra it krs trldik
	banksel	adresh
	movf	adresh,w
	movwf	adbuf		; azonos lapon vannak
	movf	adresl,w
	movwf	adbuf+1
	goto	wrres	;  fogja rni a kt bjtot